#!/usr/bin/env python

"""
==============================================================================
SUPERPOSITION : Motif Finder
Authors: Osamu Maruyama (om@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
and
Daisuke Shinozaki (ma202035@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
Copyright (c) 2003 Osamu Maruyama and Daisuke Shinozaki
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in
all copies of this software.

IN NO EVENT SHALL THE AUTHOR BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF
THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE AUTHOR HAS BEEN ADVISED
OF THE POSSIBILITY OF SUCH DAMAGE.

THE AUTHOR SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
ON AN "AS IS" BASIS, AND THE AUTHOR HAS NO OBLIGATION TO
PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
==============================================================================
"""

import revcomp,sys,time

aRevComp = revcomp.RevComp()


def save_Scorefiledata(ScoreList,NumTop,Output):
    

    ScoreList.reverse()
    
    if len(ScoreList) < NumTop:
        NumTop = len(ScoreList)
    fout = open(Output.name+'.spp', 'w')
    message = '##### The best '+ str(NumTop) +' candidates. #####'
    fout.write(message)
    fout.write('\n')
    for each in range(NumTop):
        fout.write('RANK: '+str(each))
        fout.write('\n')
        fout.write('SCORE: '+str(ScoreList[each][0]))
        fout.write('\n')
        fout.write('TP: '+str(ScoreList[each][1]))
        fout.write('\n')
        fout.write('FP: '+str(ScoreList[each][2]))
        fout.write('\n')
        fout.write('Pattern: '+str(ScoreList[each][3]))
        fout.write('\n')
        fout.write('RevComp: '+str(aRevComp.make(ScoreList[each][3])))
        fout.write('\n')
        fout.write('\n')
        fout.flush()
    fout.close


def save_extract_data(ScoreList,Output):

    Save = open(Output.name + '.extract','w')
    ScoreList.reverse()
    __counter = 0
    for aScore,tp,fp,aSingle in ScoreList:
        __counter = __counter + 1
        Save.write('RANK: '+str(__counter))
        Save.write('\n')
        Save.write('SCORE: '+str(aScore))
        Save.write('\n')
        Save.write('TP: '+str(tp))
        Save.write('\n')
        Save.write('FP: '+str(fp))
        Save.write('\n')
        Save.write('Pattern: '+str(aSingle))
        Save.write('\n')
        aSingleRC = aRevComp.make(aSingle)
        Save.write('RevComp: '+str(aSingleRC))
        Save.write('\n')
        Save.write('\n')        
        Save.flush()
    Save.close()
    ScoreList.reverse()

                                 
def eachlog(lenBUF1,lenBUF1After,Bcounter,Acounter,_logSave2,Pattern1,SCORELIST):

    logSave2 = open(_logSave2,'a')
    logSave2.write('------------------------- ')
    logSave2.write('check : ' + time.ctime(time.time()) + '\n')
    logSave2.write('\n')
    logSave2.write('Pattern1: '+str(Pattern1) )
    logSave2.write('\n')
    logSave2.write('\n')
    logSave2.write('size of sorted list')
    logSave2.write('\n')
    logSave2.write('Before superposition: '+str(lenBUF1) + '\n')
    logSave2.write('After superposition : '+str(lenBUF1After) + '\n')
    rate = float(lenBUF1After-lenBUF1)/float(lenBUF1)*100.0
    logSave2.write('the rate of increase :'+str(rate)+'%'+'\n')

    if rate < 0.0:
        logSave2.write('### CHECK ###'+'\n')

    logSave2.write('\n')
    logSave2.write('SCORELIST'+'\n')
    SCORELIST.ScoreList.reverse()
    for each in SCORELIST.ScoreList:
        logSave2.write(str(each)+'\n')
    SCORELIST.ScoreList.reverse()

    logSave2.write('\n')
    logSave2.write('#(Superposed pattern): '+str(Bcounter)+'+'+str(Acounter-Bcounter)+'='+str(Acounter)+'\n')
    logSave2.write('\n')
    logSave2.close()



