#!/usr/bin/env python

"""
==============================================================================
SUPERPOSITION : Motif Finder
Authors: Osamu Maruyama (om@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
and
Daisuke Shinozaki (ma202035@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
Copyright (c) 2003 Osamu Maruyama and Daisuke Shinozaki
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in
all copies of this software.

IN NO EVENT SHALL THE AUTHOR BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF
THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE AUTHOR HAS BEEN ADVISED
OF THE POSSIBILITY OF SUCH DAMAGE.

THE AUTHOR SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
ON AN "AS IS" BASIS, AND THE AUTHOR HAS NO OBLIGATION TO
PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
==============================================================================
"""

import string


class RevComp:
    def __init__(self):
        self.tab = {"A" : "T","T" : "A","C" : "G","G" : "C",
                    'R' : 'Y',
                    'Y' : 'R', 
                    'M' : 'K',
                    'K' : 'M',
                    'W' : 'W',
                    'S' : 'S',
                    "N" : "N",
                    "B" : "V",
                    "V" : "B",
                    "D" : "H",
                    "H" : "D"
                    }

    def make(self,sequence):
        buf = []
        N = len(sequence)
        for p in range(N):
            buf.append(self.tab[sequence[N - p - 1]])
        return string.join(buf, "")
        


def reverse_complement(sequence):
    tab = {
        "A" : "T",
        "T" : "A",
        "C" : "G",
        "G" : "C",

        'R' : 'Y',
        'Y' : 'R', 
        'M' : 'K',
        'K' : 'M',
        'W' : 'W',
        'S' : 'S',

        "N" : "N"
        }
    buf = []
    N = len(sequence)
    for p in range(N):
        buf.append(tab[sequence[N - p - 1]])
    # buf.reverse()
    return string.join(buf, "")



# class RevComp:
#     def get(self,seq):
#         pass

# RevComp().get('ATW')

# a = RevComp()
# a.get('ATW')
