#!/usr/bin/env python

"""
==============================================================================
SUPERPOSITION : Motif Finder
Authors: Osamu Maruyama (om@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
and
Daisuke Shinozaki (ma202035@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
Copyright (c) 2003 Osamu Maruyama and Daisuke Shinozaki
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in
all copies of this software.

IN NO EVENT SHALL THE AUTHOR BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF
THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE AUTHOR HAS BEEN ADVISED
OF THE POSSIBILITY OF SUCH DAMAGE.

THE AUTHOR SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
ON AN "AS IS" BASIS, AND THE AUTHOR HAS NO OBLIGATION TO
PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
==============================================================================
"""


import sys

def change_degenerate(chara1,chara2):
        
    Dtab = {('A','C'):'M',('A','G'):'R',('A','T'):'W',
            ('C','G'):'S',('C','T'):'Y',
            ('G','T'):'K',
            
            ('A','K'):'D',('A','S'):'V',('A','Y'):'H',
            ('A','M'):'M',('A','R'):'R',('A','W'):'W',
            ('C','K'):'B',('C','S'):'S',('C','Y'):'Y',
            ('C','M'):'M',('C','R'):'V',('C','W'):'H',
            ('G','K'):'K',('G','S'):'S',('G','Y'):'B',
            ('G','M'):'V',('G','R'):'R',('G','W'):'D',
            ('T','W'):'W',('T','Y'):'Y',('K','T'):'K',
            ('M','T'):'H',('R','T'):'D',('S','T'):'B',
            
            ('K','M'):'N',('K','R'):'D',('K','S'):'B',
            ('K','W'):'D',('K','Y'):'B',
            ('M','R'):'V',('M','S'):'V',('M','W'):'H',('M','Y'):'H',
            ('R','S'):'V',('R','W'):'D',('R','Y'):'N',
            ('S','W'):'N',('S','Y'):'B',
            ('W','Y'):'H',
            
            ('A','B'):'N',('A','D'):'D',('A','H'):'H',('A','V'):'V',
            ('B','C'):'B',('C','D'):'N',('C','H'):'H',('C','V'):'V',
            ('B','G'):'B',('D','G'):'D',('G','H'):'N',('G','V'):'V',
            ('B','T'):'B',('D','T'):'D',('H','T'):'H',('T','V'):'N',

            ('B','K'):'B',('B','S'):'B',('B','Y'):'B',
            ('B','M'):'N',('B','R'):'N',('B','W'):'N',
            ('D','K'):'D',('D','S'):'N',('D','Y'):'N',
            ('D','M'):'N',('D','R'):'D',('D','W'):'D',
            ('H','K'):'N',('H','S'):'N',('H','Y'):'H',
            ('H','M'):'H',('H','R'):'N',('H','W'):'H',
            ('V','W'):'N',('V','Y'):'N',('K','V'):'N',
            ('M','V'):'V',('R','V'):'V',('S','V'):'V',

            ('B','D'):'N',('B','H'):'N',('B','V'):'N',
            ('D','H'):'N',('D','V'):'N',
            ('H','V'):'N',

            ('A','N'):'N',('C','N'):'N',('G','N'):'N',
            ('N','T'):'N',('N','S'):'N',('N','W'):'N',
            ('M','N'):'N',('K','N'):'N',('N','R'):'N',
            ('N','Y'):'N',('B','N'):'N',('D','N'):'N',
            ('H','N'):'N',('N','V'):'N',
            }
        
    if chara1 < chara2:
        charaset = (chara1,chara2)
    else:
        charaset = (chara2,chara1)
        
    charaD = Dtab[charaset]

    if charaD == 'no':
        return None

    return charaD

###############
def charaTest():
    CharaSet =(('A','C'),('A','G'),('A','T'),
               ('C','G'),('C','T'),('G','T'),
               
               ('A','K'),('A','S'),('A','Y'),
               ('A','M'),('A','R'),('A','W'),
               ('C','K'),('C','S'),('C','Y'),
               ('C','M'),('C','R'),('C','W'),
               ('G','K'),('G','S'),('G','Y'),
               ('G','M'),('G','R'),('G','W'),
               ('T','W'),('T','Y'),('K','T'),
               ('M','T'),('R','T'),('S','T'),
            
               ('K','M'),('K','R'),('K','S'),
               ('K','W'),('K','Y'),
               ('M','R'),('M','S'),('M','W'),('M','Y'),
               ('R','S'),('R','W'),('R','Y'),
               ('S','W'),('S','Y'),
               ('W','Y'),
            
               ('A','B'),('A','D'),('A','H'),('A','V'),
               ('B','C'),('C','D'),('C','H'),('C','V'),
               ('B','G'),('D','G'),('G','H'),('G','V'),
               ('B','T'),('D','T'),('H','T'),('T','V'),

               ('B','K'),('B','S'),('B','Y'),
               ('B','M'),('B','R'),('B','W'),
               ('D','K'),('D','S'),('D','Y'),
               ('D','M'),('D','R'),('D','W'),
               ('H','K'),('H','S'),('H','Y'),
               ('H','M'),('H','R'),('H','W'),
               ('V','W'),('V','Y'),('K','V'),
               ('M','V'),('R','V'),('S','V'),

               ('B','D'),('B','H'),('B','V'),
               ('D','H'),('D','V'),
               ('H','V'),

               ('A','N'),('C','N'),('G','N'),
               ('N','T'),('N','S'),('N','W'),
               ('M','N'),('K','N'),('N','R'),
               ('N','Y'),('B','N'),('D','N'),
               ('H','N'),('V','N')
               )
    for eachpair in CharaSet:
        chara1 = eachpair[0]
        chara2 = eachpair[1]
        print chara1
        print chara2
        charaD = change_degenerate(chara1,chara2)
        print charaD
    sys.exit()
###############
    
if __name__ == '__main__':
    charaTest()
