#!/usr/bin/env python

"""
==============================================================================
SUPERPOSITION : Motif Finder
Authors: Osamu Maruyama (om@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
and
Daisuke Shinozaki (ma202035@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
Copyright (c) 2003 Osamu Maruyama and Daisuke Shinozaki
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in
all copies of this software.

IN NO EVENT SHALL THE AUTHOR BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF
THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE AUTHOR HAS BEEN ADVISED
OF THE POSSIBILITY OF SUCH DAMAGE.

THE AUTHOR SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
ON AN "AS IS" BASIS, AND THE AUTHOR HAS NO OBLIGATION TO
PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
==============================================================================
"""

import sys,re,string

###############

def OCTcomplete(OccurrenceCountTree,length,ExSeq):

    PatNo = 0
    totalNum = pow(4,length)
    while PatNo < totalNum:
        Pattern = ''
        TmpPattern = []
        CharNo = PatNo % 4
        TmpPattern.append(Change_Chara(str(CharNo)))
        QuoNo = PatNo / 4
        while QuoNo != 0:
             CharNo = QuoNo % 4
             TmpPattern.append(Change_Chara(str(CharNo)))
             QuoNo = QuoNo / 4
        if len(TmpPattern) < length:
            lenPat = len(TmpPattern)
            for m in range(length - lenPat):
                TmpPattern.append(Change_Chara(str(0)))
        for each in TmpPattern:
            Pattern = Pattern + each
        Pattern = splitPattern(Pattern,length)
        #print Pattern
        
        if not OccurrenceCountTree.has_key(Pattern):
            OccurrenceCountTree[Pattern] = {}
            for each in ExSeq.keys(): # = ['P','N']
                OccurrenceCountTree[Pattern][each] = [0] * len(ExSeq[each])
        
        PatNo = PatNo + 1
    return OccurrenceCountTree
    sys.exit()

############### SUB1 #

def Change_Chara(each):

    table = {'0': 'A', '1': 'C', '2': 'G', '3': 'T'}
    return table[each]

############### SUB2 #

def splitPattern(Pattern,length):
    Llength = length /2
    RetPattern = (Pattern[0:Llength], 0,Pattern[Llength:length])
    return RetPattern
    

###############
#   T E S T   #
###############

def test():
    OccurrenceCountTree = 3
    length = 4
    OCTcomplete(OccurrenceCountTree,length)

###############
if __name__ == '__main__':
    test()
    sys.exit()

