#!/usr/bin/env python

"""
==============================================================================
SUPERPOSITION : Motif Finder
Authors: Osamu Maruyama (om@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
and
Daisuke Shinozaki (ma202035@math.kyushu-u.ac.jp)
Faculty of Mathematics, Kyushu University
Copyright (c) 2003 Osamu Maruyama and Daisuke Shinozaki
All rights reserved.

Permission is hereby granted, without written agreement and without
license or royalty fees, to use, copy, modify, and distribute this
software and its documentation for any purpose, provided that the
above copyright notice and the following two paragraphs appear in
all copies of this software.

IN NO EVENT SHALL THE AUTHOR BE LIABLE TO ANY PARTY FOR DIRECT, INDIRECT,
SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OF
THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE AUTHOR HAS BEEN ADVISED
OF THE POSSIBILITY OF SUCH DAMAGE.

THE AUTHOR SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE PROVIDED HEREUNDER IS
ON AN "AS IS" BASIS, AND THE AUTHOR HAS NO OBLIGATION TO
PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
==============================================================================
"""

import string,random


def make_random_sequence_of_length(k):
    alphabet = ['a','t','c','g']
    _prefix = []
    for each in range(k):
        x = random.randrange(4)
        _prefix.append(alphabet[x])
    return string.join(_prefix,"")


def ScanFileLineByLine(file_name):
    input = open(file_name)
    if not input:
        print 'Can\'t open the file: ', file_name, '.'
        exit()
    list = []
    while 1:
        line = input.readline()
        if not line:
            break
        line = string.strip(line)
        if not line:
            pass
        elif "#" == line[0]:
            pass
        else:
            list.append(line)
    return list


def reverse(input):
    buf = []
    N = len(input)
    for p in range(N):
        buf.append(input[N - p - 1])
    return string.join(buf, "")

def compare_third_term(left, right):
    if left[2] < right[2]:
        return 1 
    elif left[2] > right[2]:
        return -1
    else:
        return 0

def compare_second_term(left, right):
    if left[1] < right[1]:
        return 1 
    elif left[1] > right[1]:
        return -1
    else:
        return 0

if __name__ == "__main__":
    print make_random_sequence_of_length(2)
    print make_random_sequence_of_length(3)
    print make_random_sequence_of_length(4)
    print make_random_sequence_of_length(5)
    print make_random_sequence_of_length(6) 
    assert(reverse("ABC") == "CBA")
    print ScanFileLineByLine("util.py")
